//
//  FriendsInteractor.swift
//  VK Tosters
//
//  Created programmist_np on 21/01/2020.
//  Copyright © 2020 programmist_np. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import Foundation
import UIKit
import SwiftyVK
import SwiftyJSON
import RealmSwift

class FriendsInteractor: NSObject, FriendsInteractorProtocol {
    weak var presenter: FriendsPresenterProtocol?
    var service: FriendsService?

    func start(request: FriendModel.Request.RequestType) {
        makeRequest(request: request)
    }
    
    func makeRequest(request: FriendModel.Request.RequestType) {
        if service == nil {
            service = FriendsService()
        }

        switch request {
        case .getFriend:
            presenter?.presentData(response: .presentFooterLoader)
            service?.getFriends(userId: VKConstants.currentUserId, completion: { [weak self] (friends) in
                guard let self = self else { return }
                self.presenter?.presentData(response: .presentFriend(response: friends))
                }, failed: { [weak self] error in
                    guard let self = self else { return }
                    self.presenter?.presentData(response: .presentFooterError(message: error))
            })
        default:
            break
        }
    }
}
